BLECharacteristic *pCharacteristic;
bool deviceConnected = false;







class MyServerCallbacks: public BLEServerCallbacks {
    void onConnect(BLEServer* pServer) {
      deviceConnected = true;
      Serial.println("A device has connected via BLE");
    };

    void onDisconnect(BLEServer* pServer) {
      deviceConnected = false;
      Serial.println("BTLE device has disconnected");
    }
};

class MyCallbacks: public BLECharacteristicCallbacks {
    void onWrite(BLECharacteristic *pCharacteristic) {
      std::string rxValue = pCharacteristic->getValue();

      if (rxValue.length() > 0) {
        Serial.println("*********");
        Serial.print("Received Value: ");

        last_inp="";
        for (int i = 0; i < rxValue.length(); i++) {
          Serial.print(rxValue[i]);
          last_inp += rxValue[i];
          
        }

        Serial.println();
        char cmd = last_inp[0];
        Serial.println(last_inp);
        Serial.print("Received cmd: ");
        Serial.println(cmd);
        String param= last_inp.substring(1,last_inp.length());
        Serial.print("Received parameter: ");
        Serial.println(param);

        switch (cmd){
          case '1':{//Control LED
            Serial.println("Received LED control command");
            if (param == "A"){
              Serial.println("LED1 on");
              digitalWrite(LED1, HIGH);
            }
            if (param == "B"){
              Serial.println("LED1 off");
              digitalWrite(LED1,LOW);
            }
            break;
          }
          case '2':{//Control LED
            Serial.println("Received LED control command");
            if (param == "A"){
              Serial.println("LED2 on");
              digitalWrite(LED2, HIGH);
            }
            if (param == "B"){
              Serial.println("LED2 off");
              digitalWrite(LED2,LOW);
            }
            break;
          }
case '3':{//Control LED
            Serial.println("Received LED control command");
            if (param == "A"){
              Serial.println("LED on");
              digitalWrite(LED3, HIGH);
            }
            if (param == "B"){
              Serial.println("LED3 off");
              digitalWrite(LED3,LOW);
            }
            break;
          }

          case '4':{//Control LED
            Serial.println("Received LED control command");
            if (param == "A"){
              Serial.println("LED4 on");
              digitalWrite(LED4, HIGH);
            }
            if (param == "B"){
              Serial.println("LED4 off");
              digitalWrite(LED4,LOW);
            }
            break;
          }

          case '5':{//Control LED
            Serial.println("Received LED control command");
            if (param == "A"){
              Serial.println("LED5 on");
              digitalWrite(LED5, HIGH);
            }
            if (param == "B"){
              Serial.println("LED5 off");
              digitalWrite(LED5,LOW);
            }
            break;
          }

          case '6':{//Control LED
            Serial.println("Received LED control command");
            if (param == "A"){
              Serial.println("LED6 on");
              digitalWrite(LED6, HIGH);
            }
            if (param == "B"){
              Serial.println("LED6 off");
              digitalWrite(LED6,LOW);
            }
            break;
          }
          
          case 'A':{
            inc_msg = param;
            break;
          }
          default:{
            Serial.println("Unkown Command");
          }
        }

        Serial.println();
        Serial.println("*********");
      }
    }
};



void ble_init(){
  Serial.println("BLE Init...");
  // Create the BLE Device

  BLEDevice::init(dev_name);

  // Create the BLE Server
  BLEServer *pServer = BLEDevice::createServer();
  pServer->setCallbacks(new MyServerCallbacks());

  // Create the BLE Service
  BLEService *pService = pServer->createService(SERVICE_UUID);

  // Create a BLE Characteristic
  pCharacteristic = pService->createCharacteristic(
                      CHARACTERISTIC_UUID_TX,
                      BLECharacteristic::PROPERTY_NOTIFY
                    );
                      
  pCharacteristic->addDescriptor(new BLE2902());

  BLECharacteristic *pCharacteristic = pService->createCharacteristic(
                                         CHARACTERISTIC_UUID_RX,
                                         BLECharacteristic::PROPERTY_WRITE
                                       );


  pCharacteristic->setCallbacks(new MyCallbacks());

  // Start the service
  pService->start();

  // Start advertising
  pServer->getAdvertising()->start();
  Serial.println("BLE Init...Finished");
}
